;68030 bus error display v0.3
;
;

	.include IOCSCALL.MAC
	.include DOSCALL.MAC


	.cpu	68030

PRINT		.macro	addr
		lea	addr,a1
		IOCS	_B_PRINT
		.endm

CRLF		.macro
		bsr	crlf
		.endm


		.offset	0
f_SR:		.ds.w	1	;
f_PC:		.ds.l	1	;
f_VEC:		.ds.w	1	; Vector offset
f_IR08:		.ds.w	1	;
f_SSR:		.ds.w	1	; Spesial status register
f_IPSC		.ds.w	1	; pipe C
f_IPSB		.ds.w	1	; pipe B
f_DCFA:		.ds.l	1	; Data cycle fault address
f_IR14:		.ds.w	1	;
f_IR16		.ds.w	1	;
f_DOBF:		.ds.l	1	;
f_size:

		.offset	f_size
fs_IR1C:	.ds.w	1	; Internal register
fs_IR1E:	.ds.w	1	; Internal register

		.offset	f_size
fl_IR1C:	.ds.w	4	;
fl_STBA:	.ds.l	1	; Stage-B address
fl_IR28:	.ds.w	2	;
fl_DIBF:	.ds.l	1	;
fl_IR30:	.ds.w	3	;
fl_VER:		.ds.w	1	; Version
fl_IR38:	.ds.w	18

		.text
top:
		.dc.l	-1
		.dc.w	$8000
		.dc.l	device_strategy
		.dc.l	device_interrupt
device_name:	.dc.b	'030*berr'

;------------------------------------------------------------
; ANZXtH[g
;------------------------------------------------------------
fault_save_regs	.reg	d0-d7/a0-a6

New_berr:	movem.l	fault_save_regs,-(sp)
		lea	((8+7)*4,sp),a6		; a6 = stack frame pointer
		move.w	(f_VEC,a6),d4		; d4 = vector offset
		cmpi.w	#$A008,d4		; short
		beq	@f
		cmpi.w	#$B008,d4		; long
		bne	frame_error
@@:		move.w	(f_SSR,a6),d5		; d5 = SSR
		bsr	get_fault_address	; a4 = fault address
		bsr	stack_frame_disp
		bsr	berr_type_disp
		bra	berr_exit

frame_error:	PRINT	(m_frame,pc)
nazo_berr:	PRINT	(m_nazo,pc)
berr_exit:	movem.l	(sp)+,fault_save_regs
		moveq	#$ff,d0			;_ABORTJOB
		trap	#15
		jmp	([orig_berr,pc])		; Ƃ肠

orig_berr:	.ds.l	1
m_nazo:		.dc.b	'nazo error',13,10,0
m_frame:	.dc.b	'stack frame format error!!',13,10,0
		.even

;------------------------------------------------------------
; tH[gAhXvZ
;------------------------------------------------------------
get_fault_address:
		btst.l	#12,d5			; RB ??
		beq	@f
		bset.l	#14,d5			; set FB
@@:		btst.l	#13,d5			; RC ??
		beq	@f
		bset.l	#15,d5			; set FC
@@:		btst.l	#8,d5			; Data fault ??
		beq	@f
		movea.l	(f_DCFA,a6),a4		; Data cycle fault address
		bra	9f

@@:		btst.l	#4+8,d4			; Long format ??
		bne	1f			;  to long format
		movea.l	(f_PC,a6),a4		; Program counter
		btst.l	#14,d5			; Stage B fault ??  (Short format)
		beq	@f
		addq.l	#4,a4
		bra	9f

@@:		btst.l	#15,d5			; Stage C fault ??  (Short format)
		beq	9f
		addq.l	#2,a4
		bra	9f

1:		movea.l	(fl_STBA,a6),a4		; Stage B address   (Long format)
		btst.l	#15,d5			; Stage C fault ??  (Long format)
		beq	9f
		subq.l	#2,a4
9:		rts

;------------------------------------------------------------
; oXG[̃^Cv\
;------------------------------------------------------------
m_SHORT:	.dc.b	'Short format',0
m_LONG:		.dc.b	'Long format',0
m_BUS_f:	.dc.b	', BUS ERROR(Hardware error??)',0
m_page:		.dc.b	', Page fault',0
m_wp:		.dc.b	', Write protect',0
m_super:	.dc.b	', Supervisor protect',0
m_Mts:		.dc.b	', PTEST failed',0
m_wf:		.dc.b	'WRITE',0
m_rf:		.dc.b	'READ',0
		.even
berr_type_disp:
		clr.l	d3
		lea	(m_SHORT,pc),a1
		btst.l	#4+8,d4			; Short format ??
		beq	@f			;  to short format
		lea	(m_LONG,pc),a1
@@:		IOCS	_B_PRINT
		bsr	crlf
		lea	(m_rf,pc),a1
		btst.l	#6,d5			; SSR, R/W flag
		bne	@f
		lea	(m_wf,pc),a1
@@:		IOCS	_B_PRINT
		ptestw	#1,(a4),#3
		subq.l	#2,sp
		pmove.w	MMUSR,(sp)
		move.w	(sp),d2
		addq.l	#2,sp

		tst.w	d2
		bpl	@f			; ptest berr
		PRINT	(m_Mts,pc)
		bra	9f

@@:		btst.l	#11,d2			; WP
		beq	@f
		PRINT	(m_wp,pc)
		st	d3

@@:		btst.l	#13,d2			; Supervisor
		beq	@f
		btst.b	#5,(f_SR,a6)		; Supervisor
		bne	@f
		PRINT	(m_super,pc)
		st	d3

@@:		btst.l	#10,d2			; Invalid
		bne	@f
		tst.b	d3
		bne	9f
		PRINT	(m_BUS_f,pc)
		bra	9f

@@:		PRINT	(m_page,pc)

9:		CRLF
		rts

;------------------------------------------------------------
; X^bNt[̕\
;------------------------------------------------------------
LDISP	macro	zz
	PRINT	(zz,pc)
	move.l	(a5)+,d1
	bsr	hex8out
	CRLF
	endm

WDISP	macro	zz
	PRINT	(zz,pc)
	move.w	(a5)+,d1
	bsr	hex4out
	CRLF
	endm

BBDISP	macro	zz
	PRINT	(zz,pc)
	move.w	(a5)+,d1
	bsr	bin16out
	CRLF
	endm

BDISP	macro	zz
	PRINT	(zz,pc)
	move.w	(a5)+,d1
	bsr	bin8out
	CRLF
	endm

stack_frame_disp:
		move.b	(disp_ir,pc),d6

		PRINT	(m_fa,pc)
		move.l	a4,d1
		bsr	hex8out

		lea	(a6),a5
		CRLF
		BBDISP	m_sr
		LDISP	m_pc
		WDISP	m_vec
		tst.b	d6
		beq	1f
		WDISP	m_ir08
		bra	2f
1:		addq.l	#2,a5
2:		BBDISP	m_ssr
		WDISP	m_ipsc
		WDISP	m_ipsb
		LDISP	m_dcfa
		tst.b	d6
		beq	1f
		WDISP	m_ir14
		WDISP	m_ir16
		bra	2f
1:		addq.l	#2*2,a5
2:		LDISP	m_dobf
		btst.l	#4+8,d4			; Long format ??
		bne	8f			;  to long format
		tst.b	d6
		beq	1f
		WDISP	ms_ir1c
		WDISP	ms_ir1e
		bra	2f
1:		addq.l	#2*2,a5
2:		bra	9f


8:		tst.b	d6
		beq	1f
		PRINT	(ml_ir1c,pc)
		moveq	#4-1,d2
@@:		move.w	(a5)+,d1
		bsr	hex4out
		bsr	putspc
		dbra	d2,@b
		CRLF
		bra	2f
1:		addq.l	#4*2,a5
2:		LDISP	ml_stba

		tst.b	d6
		beq	1f
		PRINT	(ml_ir28,pc)
		moveq	#2-1,d2
@@:		move.w	(a5)+,d1
		bsr	hex4out
		bsr	putspc
		dbra	d2,@b
		CRLF
		bra	2f
1:		addq.l	#2*2,a5
2:		LDISP	ml_dibf

		tst.b	d6
		beq	1f
		PRINT	(ml_ir30,pc)
		moveq	#3-1,d2
@@:		move.w	(a5)+,d1
		bsr	hex4out
		bsr	putspc
		dbra	d2,@b
		CRLF
		bra	2f
1:		addq.l	#2*3,a5
2:		WDISP	ml_ver

		tst.b	d6
		beq	1f
		PRINT	(ml_ir38,pc)
		moveq	#9-1,d2
@@:		move.w	(a5)+,d1
		bsr	hex4out
		bsr	putspc
		dbra	d2,@b
		CRLF
		PRINT	(ml_spc,pc)
		moveq	#9-1,d2
@@:		move.w	(a5)+,d1
		bsr	hex4out
		bsr	putspc
		dbra	d2,@b
		CRLF
1:		lea	(18*2,a5),a5
2:
9:
		lea	(m_dreg,pc),a1
		lea	(-((8+7)*4),a6),a5
		moveq	#8-1,d2
		bsr	slw_print
		CRLF

		moveq	#7-1,d2
		bsr	slw_print

		movec	usp,d1
		bsr	hex8out
		bsr	putspc

		moveq	#16*2,d1		; short size
		btst.l	#4+8,d4			; Short format ??
		beq	@f			;  to short format
		moveq	#46*2,d1
@@:		lea	(a6,d1.l),a5		; X^bNt[̕𑫂
		move.l	a5,d1
		bsr	hex8out

		CRLF
		rts


slw_print:	IOCS	_B_PRINT
@@:		move.l	(a5)+,d1
		bsr	hex8out
		bsr	putspc
		dbra	d2,@b
		rts

m_fa:		.dc.b	'  FA:$',0

m_sr:		.dc.b	'  SR:%',0
m_pc:		.dc.b	'  PC:$',0
m_vec:		.dc.b	' VEC:$',0
m_ir08:		.dc.b	'IR08:$',0
m_ssr:		.dc.b	' SSR:%',0
m_ipsc		.dc.b	'IPSC:$',0
m_ipsb		.dc.b	'IPSB:$',0
m_dcfa:		.dc.b	'DCFA:$',0
m_ir14:		.dc.b	'IR14:$',0
m_ir16		.dc.b	'IR16:$',0
m_dobf:		.dc.b	'DOBF:$',0

ms_ir1c:	.dc.b	'IR1C:$',0
ms_ir1e:	.dc.b	'IR1E:$',0

ml_ir1c:	.dc.b	'IR1C:$',0
ml_stba:	.dc.b	'STBA:$',0
ml_ir28:	.dc.b	'IR28:$',0
ml_dibf:	.dc.b	'DIBF:$',0
ml_ir30:	.dc.b	'IR30:$',0
ml_ver:		.dc.b	' VER:$',0
ml_ir38:	.dc.b	'IR38:$',0
ml_spc:		.dc.b	'     $',0

m_dreg:		.dc.b	'data:$',0
m_areg:		.dc.b	'addr:$',0

		.even

;------------------------------------------------------------
; d1 PUi\
;------------------------------------------------------------
hex8out:	swap	d1
		bsr	hex4out
		swap	d1
hex4out:	ror.w	#8,d1
		bsr	hex2out
		rol.w	#8,d1
hex2out:	ror.w	#4,d1
		bsr	hex1out
		rol.w	#4,d1
hex1out:	movem.l	d0/d1,-(sp)
		andi.w	#$000F,d1
		move.b	(hextbl,pc,d1.w),d1
		IOCS	_B_PUTC
		movem.l	(sp)+,d0/d1
		rts
hextbl:		dc.b	'0123456789ABCDEF'

;------------------------------------------------------------
; d1 Qi\
;------------------------------------------------------------
bin8out:	movem.l	d0-d3,-(sp)
		move.b	d1,d3
		moveq	#7,d2
bin_loop:	move.w	#'0',d1
		btst.l	d2,d3
		beq	@f
		move.w	#'1',d1
@@:		IOCS	_B_PUTC
		dbra	d2,bin_loop
		movem.l	(sp)+,d0-d3
		rts

bin16out:	move.l	d0,-(sp)
		ror.w	#8,d1
		bsr	bin8out
		move.l	d1,-(sp)
		move.w	#'_',d1
		IOCS	_B_PUTC
		move.l	(sp)+,d1
		ror.w	#8,d1
		bsr	bin8out
		move.l	(sp)+,d0
		rts

;------------------------------------------------------------
;------------------------------------------------------------
putspc:		movem.l	d0/d1,-(sp)
		moveq	#$20,d1
		IOCS	_B_PUTC
		movem.l	(sp)+,d0/d1
		rts

crlf:		movem.l	d0/a1,-(sp)
		lea	(m_crlf,pc),a1
		IOCS	_B_PRINT
		movem.l	(sp)+,d0/a1
		rts
m_crlf:		.dc.b	13,10,0

disp_ir:	.dc.b	0

keep_bottom:
;------------------------------------------------------------
; DOS KEEPPR 풓ł͂܂
;------------------------------------------------------------
		.even
		.cpu	68000
device_reqhead:
		.ds.l	1

device_strategy:
		move.l	a5,(device_reqhead)
		rts

device_interrupt:
		movem.l	d1-d7/a0-a6,-(sp)
		movea.l	(device_reqhead,pc),a5
		tst.b	(2,a5)
		beq	device_initialize
device_error_exit:
		move.w	#$5003,d0
device_exit:
		move.b	d0,(3,a5)
		ror.w	#8,d0
		move.b	d0,(4,a5)
		ror.w	#8,d0
		movem.l	(sp)+,d1-d7/a0-a6
		rts

device_bottom:
;------------------------------------------------------------
; DEVICE o^ł͂܂
;------------------------------------------------------------

;------------------------------------------------------------
; MPU   68030 ̏ꍇ̂ d0 = 0 Ԃ
;------------------------------------------------------------
MPUcheck:	clr.l	d0
		cmpi.b	#3,($0CBC).w
		beq	@f
		pea	(illegal_mpu,pc)
		DOS	_PRINT
		addq.l	#4,sp
		moveq	#-1,d0
@@:		rts

;------------------------------------------------------------
; foCXhCo
;------------------------------------------------------------
device_initialize:
		pea	(dev_message,pc)
		DOS	_PRINT
		addq.l	#4,sp
		bsr	MPUcheck
		tst.l	d0
		bmi	device_error_exit

		lea	(New_berr,pc),a1
		moveq	#2,d1
		IOCS	_B_INTVCS
		move.l	d0,orig_berr

		move.l	#'BERR',(device_name+4)
		move.l	#device_bottom,(14,a5)

		move.l	(18,a5),a0
@@:		tst.b	(a0)+
		bne	@b
getparam:	move.b	(a0)+,d1
		bne	@f
		move.b	(a0)+,d1
		beq	no_param

@@:		cmpi.b	#'*',d1
		bne	getparam
		st	(disp_ir)
		bra	getparam

no_param:
		clr.l	d0
		bra	device_exit

;------------------------------------------------------------
; R}hs
;------------------------------------------------------------
command_entry:
		suba.l	a1,a1
		IOCS	_B_SUPER
		move.l	d0,d6

		pea	(name,pc)
		DOS	_PRINT
		addq.l	#4,sp
		bsr	MPUcheck
		tst.l	d0
		bmi	go_exit

		lea	(New_berr,pc),a1
		moveq	#2,d1
		IOCS	_B_INTVCS
		move.l	d0,orig_berr
		movea.l	d0,a0
		lea	(-(New_berr-device_name),a0),a0
		lea	(device_name,pc),a1
		cmpm.l	(a0)+,(a1)+
		bne	go_keep
		cmpm.l	(a1)+,(a0)+
		bne	go_keep

		lea	(-(device_name+8-top),a0),a0
		movea.l	(orig_berr-top,a0),a1
		moveq	#2,d1
		IOCS	_B_INTVCS

		pea	(-$f0,a0)
		DOS	_MFREE
		addq.l	#4,sp
		tst.l	d0
		bne	mfree_fail
		pea	(m_mfree_ok,pc)
		bra	kaijo_exit

mfree_fail:	pea	(m_mfree_fail,pc)
kaijo_exit:	DOS	_PRINT
		addq.l	#4,sp
go_exit:	movea.l	d6,a1
		IOCS	_B_SUPER
		DOS	_EXIT

go_keep:	tst.b	(a2)+
		beq	@f
		cmpi.b	#'*',(a2)
		bne	@f
		st	(disp_ir)
@@:		pea	(m_keeppr_ok,pc)
		DOS	_PRINT
		addq.l	#4,sp
		movea.l	d6,a1
		IOCS	_B_SUPER
		clr.w	-(sp)
		pea	(keep_bottom-top).w
		DOS	_KEEPPR


dev_message:	.dc.b	13,10
name:		.dc.b	'68030 bus error display v0.3 by bisco',13,10,0
illegal_mpu:	.dc.b	'68030pȂ',13,10,0
m_keeppr_ok:	.dc.b	'풓',13,10,'oXG[łւ炳(E\',13,10,0
m_mfree_fail:	.dc.b	'sIҁ[',13,10,0
m_mfree_ok:	.dc.b	'܂',13,10,0


	.end	command_entry
